package m200;


import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.messages.M200Msg;
import m200.messages.M200MsgFactory;
import m200.transceiver.M200MessageBody;
import m200.transceiver.TransmissionLayer;
import m200.transceiver.TransmissionLayerReceiver;

public class M200Iface implements TransmissionLayerReceiver {
	public interface M200MsgReceiver{
		void NewM200Message(M200Msg msg);
	}
	private TransmissionLayer tlDriver;
	private String addr;
	private int port;
	private M200MsgReceiver rcv;

	public M200Iface(String addr,int port,M200MsgReceiver rcv) {
		tlDriver=new TransmissionLayer(this);
		this.addr=addr;
		this.port=port;
		this.rcv=rcv;
	}

	public void process() {
		if(tlDriver.connect(addr,port)){
		}
	}

	@Override
	public void newMessage(M200MessageBody mb) {
		//System.err.println("-> {"+mb.data.length+"} "+mb.rTime+" "+Long.toHexString(mb.callId)+" "+M200Util.msgType2Str(mb.msgType));
		try {
			M200Msg msg=M200MsgFactory.instance(mb);
			//System.out.println("-> "+msg);
			rcv.NewM200Message(msg);
		} catch (M200MsgClassNotEqMsgTypeException e) {
			e.printStackTrace();
		}
		
	}
	public void stop() {
		tlDriver.close();
	}
	
}
