package m200.messages;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200MessageBody;
import m200.transceiver.M200Util;

public abstract class M200Msg {
	protected M200MessageBody body;
	protected abstract boolean isTypeValid();
	protected abstract void bodyReady();
	public abstract M200Msg cloneNew();
	public void setBody(M200MessageBody b) throws M200MsgClassNotEqMsgTypeException{
		body=b;
		if(!isTypeValid()) throw new M200MsgClassNotEqMsgTypeException(body.msgType,this);
		bodyReady();
	}
	public String toString(){
		return "{"+body.data.length+"}"+" "+ body.rTime+" "+Long.toHexString(body.callId)+" "+M200Util.msgType2Str(body.msgType);
	}
	public long getCallId(){
		return body.callId;
	}
	public int getBodyType() {
		return body.msgType;
	}
	public String toHumanString() {
		return M200Util.msgType2HStr(body.msgType);
	}
}
