package m200.messages;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200Util;


public class M200MsgCall extends M200Msg {
	private static final int TYPE=13;
	 // remID:DWORD sig:BYTE module:BYTE slot/pcm:BYTE port/ki:BYTE number:STRING aon:STRING
	protected boolean isTypeValid(){
		return (TYPE==body.msgType);
	}
	public M200Msg cloneNew(){
		 return new M200MsgCall(); 
	}
	public String toString(){
		return super.toString()+" r:"+Long.toHexString(M200Util.getDWORD(body.data,body.HEADERLEN))+" "+M200Util.sig2Str(body.data[body.HEADERLEN+4])+"("+body.data[body.HEADERLEN+4]+")"+
		" m:"+body.data[body.HEADERLEN+5]+" p:"+body.data[body.HEADERLEN+6]+" k:"+body.data[body.HEADERLEN+7]+
		" n:"+M200Util.getString(body.data,body.HEADERLEN+8)+" a:"+M200Util.getString(body.data,body.HEADERLEN+8+M200Util.getString(body.data,body.HEADERLEN+8).length()+1);
	}
	public static int getType() {
		return TYPE;
	}
	public static M200MsgCall cast(M200Msg msg) throws M200MsgClassNotEqMsgTypeException {
		try{
			return M200MsgCall.class.cast(msg);
		}catch (ClassCastException e){
			throw new M200MsgClassNotEqMsgTypeException(M200MsgCall.class.getSimpleName(),msg);
		}
	}
	public long getRefId() {
		return M200Util.getDWORD(body.data,body.HEADERLEN);
	}
	public String toHumanString() {
		return super.toHumanString()+" "+M200Util.sig2HStr(body.data[body.HEADERLEN+4])+" "+body.data[body.HEADERLEN+5]+"/"+body.data[body.HEADERLEN+6]+"/"+body.data[body.HEADERLEN+7]+
		" t:"+M200Util.getString(body.data,body.HEADERLEN+8)+" f:"+M200Util.getString(body.data,body.HEADERLEN+8+M200Util.getString(body.data,body.HEADERLEN+8).length()+1);
	}
	public int getLocation(){
		return body.data[body.HEADERLEN+5]*100+body.data[body.HEADERLEN+6];
	}

	@Override
	protected void bodyReady() {
	}
}
