package m200.messages;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200Util;


public class M200MsgSeizure extends M200Msg {
	private static final int TYPE=10;
	 // sig:BYTE module:BYTE slot/pcm:BYTE port/ki:BYTE number:STRING aon:STRING
	protected boolean isTypeValid(){
		return (TYPE==body.msgType);
	}
	public M200Msg cloneNew(){
		 return new M200MsgSeizure(); 
	}
	public String toString(){
		return super.toString()+" "+M200Util.sig2Str(body.data[body.HEADERLEN])+"("+body.data[body.HEADERLEN]+")"+
		" m:"+body.data[body.HEADERLEN+1]+" p:"+body.data[body.HEADERLEN+2]+" k:"+body.data[body.HEADERLEN+3]+
		" n:"+M200Util.getString(body.data,body.HEADERLEN+4)+" a:"+M200Util.getString(body.data,body.HEADERLEN+4+M200Util.getString(body.data,body.HEADERLEN+4).length()+1);
	}
	public String toHumanString(){
		return super.toHumanString()+" "+M200Util.sig2HStr(body.data[body.HEADERLEN])+
		" "+body.data[body.HEADERLEN+1]+"/"+body.data[body.HEADERLEN+2]+"/"+body.data[body.HEADERLEN+3]+
		" t:"+M200Util.getString(body.data,body.HEADERLEN+4)+" f:"+M200Util.getString(body.data,body.HEADERLEN+4+M200Util.getString(body.data,body.HEADERLEN+4).length()+1);
	}

	public static int getType() {
		return TYPE;
	}
	public static M200MsgSeizure cast(M200Msg msg) throws M200MsgClassNotEqMsgTypeException {
		try{
			return M200MsgSeizure.class.cast(msg);
		}catch (ClassCastException e){
			throw new M200MsgClassNotEqMsgTypeException(M200MsgSeizure.class.getSimpleName(),msg);
		}
	}
	public int getLocation(){
		return body.data[body.HEADERLEN+1]*100+body.data[body.HEADERLEN+2];
	}
	@Override
	protected void bodyReady() {
	}

}
