package m200.transceiver;

public class M200MessageBody {
	public final int HEADERLEN=6;
	public final int MAXSIZEDATAMON=100;
	public int rTime; // относительное время в секундах
	public long callId;  // идентификатор вызова
	public int msgType; // мессага
	public byte[] data; //!!! параметры мессаги c заголовком!!!
	public M200MessageBody(byte[] buf) {
		if(buf.length<HEADERLEN) return;
	    rTime = M200Util.byte2int(buf[0]);
	    callId= M200Util.byte2int(buf[1]);
//	    System.err.print("c "+callId);
	    callId |= M200Util.byte2int(buf[2]) << 8;
//	    System.err.print("- "+callId+" ("+M200Util.byte2int(buf[2])+")"+"["+(M200Util.byte2int(buf[2]) << 8)+"]");
	    callId |= M200Util.byte2int(buf[3]) << 16;
//	    System.err.print("- "+callId+" ("+M200Util.byte2int(buf[3])+")"+"["+(M200Util.byte2int(buf[3]) << 16)+"]");
	    callId |= (long)M200Util.byte2int(buf[4]) << 24;
//	    System.err.println("- "+callId+" ("+M200Util.byte2int(buf[4])+")"+"["+((long)M200Util.byte2int(buf[4]) << 24)+"]");
	    msgType = M200Util.byte2int(buf[5]);                    
	    if ((buf.length-HEADERLEN) > MAXSIZEDATAMON) return;
	    data=buf.clone();
	}
	public void printDump(){
		System.err.println("-----------------{"+data.length+"}");
		for(int i=0;i<data.length;i++){
			System.err.print(Integer.toHexString(data[i])+" ");
		}
		System.err.println();
		for(int i=0;i<data.length;i++){
			if(data[i]<0x20 || data[i]>0x7e ) System.err.print(data[i]+"<"+Integer.toHexString(data[i])+">");
			else {
				System.err.write(data,i,1);
			}
		}
		System.err.println();
		System.err.println("-----------------");
	}
}
