package m200.transceiver;



import java.io.IOException;
import java.io.InputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;




public class TransmissionLayer implements Runnable{

private Socket sock;
private TransmissionLayerReceiver tlr;
	public TransmissionLayer(TransmissionLayerReceiver tlr /*, LRCCalc lrc*/) {
//		this.lrc=lrc;
		this.tlr=tlr;
	}

	public boolean connect(String addr, int port) {
		while(true){
		try {
			sock=new Socket(addr,port);
			beginReceive();
			return true;
		} catch (UnknownHostException e) {
			e.printStackTrace();
			try {
				Thread.sleep(3000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}

		continue;
		} catch (IOException e) {
			e.printStackTrace();
			try {
				Thread.sleep(3000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}

			continue;
		}
		}
	}
	private boolean connect(InetAddress inetAddress, int port) {
		while(true){
			try {
				sock=new Socket(inetAddress,port);
				beginReceive();
				return true;
			} catch (UnknownHostException e) {
				e.printStackTrace();
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e1) {
					e1.printStackTrace();
				}

			continue;
			} catch (IOException e) {
				e.printStackTrace();
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e1) {
					e1.printStackTrace();
				}

				continue;
			}
			}
	}
	
	private void beginReceive() {
		try {
			byte[] buf=new byte[12];
			if(sock.isClosed()) return;
			if(!sock.isConnected()) return;
			InputStream bis=sock.getInputStream();
			if(bis.read(buf)==12 && buf[0]=='I'){
				for(int i=0;i<11;i++) 	System.err.write(buf,i,1);
				System.err.println(" Spider detected");
			}
			new Thread(this).start();
		} catch (IOException e) {
			e.printStackTrace();
		}
			
	}

	public void pause(int i) {
		try {
			Thread.sleep(i*1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
/*
	public synchronized void send(Command ls) {
		String record=ls.get();
		byte [] rb=ls.getBytes();
		try {
			if(sock.isClosed()) connect(sock.getInetAddress(),sock.getPort());
			System.err.print("send" +rb.length+": ");			
			for(int i=0;i<rb.length;i++){
				if(rb[i]<0x20 || rb[i]>0x7e ) System.err.print(rb[i]+"<"+Integer.toHexString(rb[i])+">");
				else {
					System.err.write(rb,i,1);
				}
			}
//			System.out.write(record.getBytes());
			System.err.println();
			System.err.flush();
			
			sock.getOutputStream().write(rb);
			
			state=WAIT_ANS;
			waitR();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public synchronized void send(String record) {
		try {
			if(sock.isClosed()) connect(sock.getInetAddress(),sock.getPort());
			System.err.print("send: ");			
			System.err.write(record.getBytes());
			System.err.println();
			System.err.flush();
			byte[] b=new byte[record.getBytes().length+1+2];
//			b[0]=(byte) 0xe1;
//			b[1]=(byte) 0xab;
			b[0]=0;
			b[1]=0;
			System.arraycopy(record.getBytes(), 0, b, 2, record.getBytes().length);
			b[b.length-1]=genCRC(record.getBytes());
			sock.getOutputStream().write(b);
			state=WAIT_ANS;
			waitR();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
*/
	private byte genCRC(byte[] bytes) {
		byte crc=0;
		for(int i=0;i<bytes.length;i++){
			crc^=bytes[i];
		}
		return crc;
	}

	private void waitR() {

		try {
			wait();
		} catch (InterruptedException e) {
			e.printStackTrace();
	
		}

/*
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
*/
	}

	
	public void run() {
		System.err.println("Receiver started");
		while(true){
		try {
			byte[] bufL=new byte[4];
			if(sock.isClosed()) return;
			if(!sock.isConnected()) return;
			InputStream bis=sock.getInputStream();
			int l=bis.read(bufL);
			if(l==-1) continue;
			if(l!=4) continue;
			int msgLen=M200Util.getDWORD(bufL);  //!!! errorable. spider use DWORD (unsigned long (4 bytes)) C macros. Java use signed types;
			byte[] buf=new byte[msgLen];
			l=bis.read(buf,0,msgLen); //!!! errorable. spider use DWORD (unsigned long (4 bytes)) C macros. Java use signed types and integer (4 bytes) in 'read' buf len;
			if(l!=msgLen) continue;
/*			
			System.err.println("-----------------");
			for(int i=0;i<msgLen;i++){
				System.err.print(Integer.toHexString(buf[i])+" ");
			}
			System.err.println();
			for(int i=0;i<msgLen;i++){
				if(buf[i]<0x20 || buf[i]>0x7e ) System.err.print(buf[i]+"<"+Integer.toHexString(buf[i])+">");
				else {
					System.err.write(buf,i,1);
				}
			}
			System.err.println("-----------------");
*/			
			tlr.newMessage(new M200MessageBody(buf));
			ready();
/*
			System.err.println();
			System.err.flush();
*/
		} catch (IOException e) {
			e.printStackTrace();
		}
		}
	}

	private synchronized void ready() {
		notifyAll();
	}

	public void close() {
		try {
			sock.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
